require 'spec_helper'
require 'object_spy'

describe ObjectSpy do

  describe '.adapter' do

    it 'uses ::Fozzie' do
      described_class.adapter.should eq(::Stats)
    end
  end

  describe '.spy' do
    let(:bulk)    { double('bulk').as_null_object }
    let(:adapter) { double('adapter') }

    let(:object_spy) do
      expect(described_class).to receive(:adapter)
        .and_return(adapter)

      expect(adapter).to receive(:bulk) {|&p| bulk.instance_eval &p }

      described_class
    end

    it 'sends bulk metrics via adapter' do
      expect(described_class.adapter).to receive(:bulk)
      described_class.spy
    end

    it "sends ObjectSpace metrics" do
      expect(bulk).to receive(:gauge).with('foo', 1)

      expect(ObjectSpace).to receive(:count_objects)
        .and_return({ foo: 1 })

      object_spy.spy
    end

    it "sends Symbol metrics" do
      expect(Symbol).to receive(:all_symbols)
        .and_return(%w{foo})

      expect(bulk).to receive(:gauge).with('symbol_count', 1)

      object_spy.spy
    end

  end

end
